



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>菜鸟之旅——.NET垃圾回收机制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">菜鸟之旅——.NET垃圾回收机制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 03:52:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　.NET的垃圾回收机制是一个非常强大的功能，尽管我们很少主动使用，但它一直在默默的在后台运行，我们仍需要意识到它的存在，了解它，做出更高效的.NET应用程序；下面我分享一下我对于垃圾回收机制（GC）的学习心得。</p>
<h1>GC的必要性</h1>
<p>　　我们知道程序会需要向内存堆使用new请求内存，然后将请求的内存初始化并使用，使用完毕之后，变清理资源和释放内存，等待别的程序来请求使用；对内存资源的管理方式，现在存在这么几种管理方式：</p>
<p>　　1、手动管理：C、C++</p>
<p>　　2、计数管理：COM</p>
<p>　　3、自动管理：.NET、JAVA、PHP</p>
<p>　　现在的高级语言基本上都实现了自动管理内存，这是因为手动管理内存会因为人为的原因产生以下问题：</p>
<p>　　1、开发人员忘记释放请求的内存，造成内存泄漏，若是内存泄露过多，则可能会造成内存溢出，导致程序无法运行；</p>
<p>　　2、应用程序访问已释放的内存，造成数据读取错误。</p>
<p>　　由此可见，手动去管理堆里面的内存可靠程度，会因开发人员的不同而不同，在C++因指针而出现的问题可不少；而且易出现Bug等乱七八糟的问题，影响系统稳定性，所以自动化管理内存是必要的。</p>
<h1>GC的工作原理</h1>
<h2>　通用概念</h2>
<h3>　　回收时机</h3>
<p>　　当应用程序分配新的对象，GC的代的预算大小已经达到阈值，比如GC的第0代已满；</p>
<p>　　代码主动显式调用System.GC.Collect()；</p>
<p>　　其他特殊情况，比如，windows报告内存不足、CLR卸载AppDomain、CLR关闭，甚至某些极端情况下系统参数设置改变也可能导致GC回收。</p>
<h3>　　应用程序根</h3>
<p>　　<strong>应用程序根</strong>（application root）：根（root）就是一个存储位置其中保存着对托管堆上一个对象的引用，根可以属性下面任何一个类别</p>
<ul><li>全局对象和静态对象的引用</li>
<li>应用程序代码库中局部对象的引用</li>
<li>传递进一个方法的对象参数的引用</li>
<li>等待被终结（finalize，后面介绍）对象的引用</li>
<li>任何引用对象的CPU寄存器</li></ul>
<h3>　　代</h3>
<p>　　垃圾回收器将托管堆(heap)里面的对象划分为3个代（一般为3代），可以使用GC.MaxGeneration()方法来进行查询当前系统所支持的最大代数：</p>
<p>　　1、G0 小对象(Size&lt;85000Byte)：新分配的小于85000字节的对象</p>
<p>　　2、G1:在GC中幸存下来的G0对象</p>
<p>　　3、G2:大对象(Size&gt;=85000Byte);在GC中幸存下来的G1对象</p>
<p>　　当一个对象被new的时候，它的代为0，经过一次回收之后，若该对象没有被回收，则代上升，变为1，若每次回收都幸存下来，则代都会上升，最大代为操作系统所支持的最大代。</p>
<p>　　因为将对象以代划分，并且可以单独回收某一个世代，避免回收整个托管堆，提升性能。一个基于代的垃圾回收器有一下特点：</p>
<p>　　1、对象越新，生存期越短；</p>
<p>　　2、对象越老，生存期越长；</p>
<p>　　3、回收堆的一部分，速度快于回收整个堆。</p>
<h2>　工作过程</h2>
<h3>　　标记对象</h3>
<p>　　在垃圾回收的第一步就是标记对象：垃圾回收器会认为托管堆中的所有对象都是垃圾，然后垃圾回收器会去检查所有的<strong>应用程序根</strong>，遍历每个根所引用到的对象，将其标记为活动的（live ），所有的根对象都检查完之后，有标记的对象就是可达对象，未标记的对象就是不可达对象，不可达对象就是回收的目标。</p>
<p>　　弱引用对象则不在考虑范围之内，所以一定会被回收掉的。</p>
<h3>　　销毁对象，释放内存</h3>
<p>　　在经过第一步的对象筛选之后，回收没有被引用的对象，就是不可达对象，GC调用对象默认的终结器Finalize()，销毁对象之后，将内存也释放掉。</p>
<p>　　同时，还存在引用的对象，就是可达对象的世代变为下一个世代。</p>
<h3>　　压缩堆内存</h3>
<p>　　经过第二步的销毁对象和释放内存之后，幸存下来的对象在堆中的排列可能是不连续的，这时在堆中存在非常多的内存碎片，程序在new对象的时候都是请求一段连续的内存，则内存碎片可能就无法再次利用（虽然没有被使用），造成内存资源的浪费，所以垃圾回收的最后一步就是压缩内存：将垃圾回收后幸存的对象移动到一起，并且将各个对象的引用更新到对象新的位置上，保证对象引用的正确性。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/977262/201802/977262-20180227163941556-1371617592.png" /></p>
<p>　　注：从这里看得出，在压缩堆内存的时候，所有相关线程必须暂停，因为压缩时不能保证对象引用的正确性，所以在垃圾回收的时候，GC会劫持所有相关线程，在回收完毕之后，被劫持的线程才会正常工作，所以垃圾回收势必会影响一定的性能，所以慎用System.GC.Collect()。</p>
<h2>　Finalize()与Dispose()</h2>
<p>　　上面说到，GC在回收对象的时候是调用对象的终结器Finalize()来实现的，那么，就简单的总结一下Finalize()与Dispose()吧：</p>
<p>　　1、调用者：</p>
<p>　　　　Finalize只能由GC调用</p>
<p>　　　　Dispose由开发人员显示调用，也可以使用use区块，在程序离开区块使自动调用Dispose方法</p>
<p>　　2、调用时机：</p>
<p>　　　　Finalize由于是GC调用的，所以调用时机是垃圾回收的时候调用，时机不确定</p>
<p>　　　　Dispose由于是显示调用，所以调用时机是确定的，在调用方法的时候就调用了</p>
<p>　　3、目的：</p>
<p>　　　　这里的目的主要说是Dispose出现的目的；</p>
<p>　　　　首先是.NET存在托管资源和非托管资源，一般来说，非托管资源数量有限，比较珍贵，在使用完毕之后，希望能够释放掉，那么将释放非托管资源的方法写到终结器Finalize里面也是可以的，但是由于Finalize的调用时机不确定，导致释放资源不及时，那么有限的非托管资源很快就被占用完毕，所以，为了能够及时的释放掉这类资源，我们需要能够显示调用的方法，这就是Dispose。</p>
<p>　　　　Finalize主要是为了GC释放托管资源和销毁对象，释放内存</p>
<p>　　　　Dispose主要是为了释放托管和非托管资源和销毁对象，释放内存</p>
<p>　　注：不必担心资源的重复释放问题，就算是重复释放，.NET也做好了相应措施来处理，不会抛出异常。</p>
<p>　　　　下面贴一个MSDN推荐的标准的Dispose实现方式</p>
<div>
<div>
<pre class="prettyprint linenums">    class Class : IDisposable<br />
    {<br />
        // 标识：是否释放托管资源<br />
        private bool disposed = false;

        // 显示调用的方法<br />
        public void Dispose()<br />
        {<br />
            Dispose(true);<br />
            // 将对象从垃圾回收器链表中移除，<br />
            // 从而在垃圾回收器工作时，只释放托管资源，而不执行此对象的析构函数<br />
            GC.SuppressFinalize(this);<br />
        }

        // 受保护的释放资源方法<br />
        protected virtual void Dispose(bool disposing)<br />
        {<br />
            if (!this.disposed)<br />
            {<br />
                if (disposing)<br />
                {<br />
                    // 此处写释放托管资源的方法<br />
                }<br />
                disposed = true;

                // 此处写释放非托管资源的方法<br />
            }<br />
        }<br />
        ~Class()<br />
        {<br />
            // 这里是防止忘记显示调用Dispose()，在GC进行垃圾回收的时候进行释放非托管资源<br />
            Dispose(false);<br />
        }<br />
    }</pre>
</div>
</div>
<h1>总结</h1>
<p>　　GC所带来的便利是不言而喻的，但是这是付出一定的系统性能来实现的：在垃圾回收的时候GC会劫持所有相关的线程，并且会有一定的时空开销，所以在平时开发过程中注意一些良好的开发习惯可能会对GC有一些积极的影响。</p>
<p>　　1、尽量不要new很大的对象，大对象（&gt;=85000Byte）直接归为G2代，GC回收算法从来不对大对象堆（LOH）进行内存压缩整理，移动大对象将会消耗更多的CPU时间，也更容易造成内存碎片。这里也可以将大对象或者生命周期长的对象进行池化。</p>
<p>　　2、不要频繁的new生命周期短的小对象，这可能会导致频繁的垃圾回收，这里可以考虑使用结构体放在栈中来代替，或者也可以使用对象池化来优化。</p>
<p>　　3、不推荐使用对象池化的解决方案，它比较笨重和容易出错，设计一个高性能稳定的对象池并不容易。</p>
<p>　　4、降低对象之间的纵向深度，GC在回收过程中，会先顺着根来进行对象遍历和标记，减少深度可以加快遍历速度；若系统中各个类之间的关系错综复杂，那么考虑一下设计方案是否合理。</p>
<p>　　当然注意的地方还有不少，最后贴一篇博客，这里介绍了<strong>如何编写高性能的.NET代码</strong>，其中的GC介绍非常详细：</p>
<p>　　<a href="http://www.cnblogs.com/yahle/p/6530246.html" rel="external nofollow noreferrer">[翻译]【目录】编写高性能 .NET 代码</a></p>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495gyveq.html">Notes&colon;indexedDB使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mjgkp8.html">android 动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq15wp69.html">Python~~~关键字~~~</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq12j459.html">JavaScript的DOM操作-重点部分-第一部分</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g6r40q.html">Streaming data from Oracle using Oracle GoldenGate and Kafka Connect</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxndvpv8.html">php读取目录及子目录下所有文件名的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd6z4d8.html">C&plus;&plus; &lowbar;access和&lowbar;waccess的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xvewv8.html">Linux协议栈函数调用流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmvg379.html">迷宫 maze</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn1v46q.html">QtCreator调试传入运行参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/950x60e8.html">linux管理员</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11yejq.html">php小写金额转大写</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjvzyr8.html">继承，is&comma;as&comma;多态</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zexmg9.html">MarkDown&sol;reST 文档发布流水线</a>
		</li>
						<li><a href="https://www.batexi.com/a/9503ne68.html">js常用语句写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgyzjm8.html">转Y-slow23原则（雅虎）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjeyd28.html">项目实战15&period;2&mdash;企业级堡垒机 jumpserver快速入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvwkgk8.html">windows pm2 启动nodejs失败：Error&colon; EBADF&colon; bad file descriptor&comma; uv&lowbar;pipe&lowbar;open</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rkjdn9.html">Pandas数据的去重，替换和离散化，异常值的检测</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv0x2x8.html">linux下拷贝文件夹的时候排除其中的一些目录</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj0ln38.html">uwsgi常用配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjxzrr8.html">system进程占用80端口</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojo2pxq.html">ScrollView（RecyclerView等）为什么会自动滚动原理分析，还有阻止自动滑动的解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1xlddq.html">HTML中padding和margin的区别和用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp4l6r9.html">Linux或Window是修改snmp的默认端口</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgml7r8.html">PHP错误杂记</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yk11r8.html">MySQL数据库学习笔记----MySQL多表查询之外键、表连接、子查询、索引</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pgwp48.html">awk脚本使用的几种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp4eo39.html">Spring事务不回滚原因分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/950yepz8.html">Prime - 程序员的修养</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
